unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, ComCtrls, ExtCtrls, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, TAGraph, TASeries, TASources, TATools,
  TATransformations, TACustomSeries, TAIntervalSources;

type

  { TForm1 }

  TForm1 = class(TForm)
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    catOscillatorLinearAxisTransform1: TLinearAxisTransform;
    catOscillator: TChartAxisTransformations;
    ChartToolset1: TChartToolset;
    ChartToolset1DataPointDragTool1: TDataPointDragTool;
    ChartToolset1PanDragTool1: TPanDragTool;
    ChartToolset1ZoomDragTool1: TZoomDragTool;
    chOscillator: TChart;
    chOscillatorLineSeries1: TLineSeries;
    lcsOscillator: TListChartSource;
    PageControl1: TPageControl;
    RandomChartSource1: TRandomChartSource;
    tsOscilloscope: TTabSheet;
    tsOwnerDrawnPointer: TTabSheet;
    timOscilloscope: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure timOscilloscopeTimer(Sender: TObject);
  end;

var
  Form1: TForm1; 

implementation

{$R *.lfm}

uses
  LCLIntf, IntfGraphics, TAChartUtils;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin

  //DateTimeIntervalChartSource1.DateTimeFormat := 'hh:mm';
  {with chOscillator.BottomAxis do begin     {BottomAxis und AxisList[1] ist das Gleiche}
  //with Chart1.AxisList[1] do begin
    Marks.Source := DateTimeIntervalChartSource1;
    Marks.Style := smsLabel;  {diese Zeile erzeugt einen "Error: Illegal Expression",}
    Range.Min:=0;          {deshalb im Objektinspektor Marks.Style auf smsLabel setzen}
    Range.Max:=1;          {0 bis 1 entspricht ein Tag}
    Range.UseMin:=True;
    Range.UseMax:=True;
  end;}

  PageControl1Change(Sender);
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  timOscilloscope.Enabled := PageControl1.ActivePage = tsOscilloscope;
end;

procedure TForm1.timOscilloscopeTimer(Sender: TObject);
var
  rp: TChartRenderingParams;
begin
  rp := chOscillator.RenderingParams;
  with chOscillatorLineSeries1 do begin
    Add(Sin(GetXMax / 20) + Random - 0.5);
    if Count > 20 then
      ListSource.Delete(0);
    // Allow to zoom into various parts of the chart
    // while preserving "oscilloscope" behaviour.
    catOscillatorLinearAxisTransform1.Offset := -GetXMin;
  end;
  // Transformation change resets logical extent.
  // We know the old extent is safe to keep, so restore it.
  chOscillator.RenderingParams := rp;
end;

end.

